#include <X11/Xlib.h>
#include <X11/keysym.h>
#include <unistd.h>

/* /usr/include/X11/keysymdef.h */
XKeyEvent createKeyEvent(Display *display, Window &win,
                           Window &winRoot, bool press,
                           int keycode, int modifiers)
{
   XKeyEvent event;

   event.display     = display;
   event.window      = win;
   event.root        = winRoot;
   event.subwindow   = None;
   event.time        = CurrentTime;
   event.x           = 1;
   event.y           = 1;
   event.x_root      = 1;
   event.y_root      = 1;
   event.same_screen = True;
   event.keycode     = XKeysymToKeycode(display, keycode);
   event.state       = modifiers;

   if(press)
      event.type = KeyPress;
   else
      event.type = KeyRelease;

   return event;
}

int sendkey(int KEYCODE)
{
   Display *display = XOpenDisplay(0);
   if(display == NULL)
      return -1;
   Window winRoot = XDefaultRootWindow(display);
   Window winFocus;
   int    revert;

   XGetInputFocus(display, &winFocus, &revert);
   XKeyEvent event = createKeyEvent(display, winFocus, winRoot, true, KEYCODE, 0);
   XSendEvent(event.display, event.window, True, KeyPressMask, (XEvent *)&event);
   XCloseDisplay(display);
   return 0;
}
